
//
// Licensed to the Apache Software Foundation (ASF) under one
// or more contributor license agreements.  See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership.  The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License.  You may obtain a copy of the License at
// 
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing,
// software distributed under the License is distributed on an
// "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied.  See the License for the
// specific language governing permissions and limitations
// under the License.
//

// This source file was created by a code generator.
// Please do not edit.

#include "qpid/management/Manageable.h"
#include "qpid/management/Buffer.h"
#include "qpid/types/Variant.h"
#include "qpid/amqp_0_10/Codecs.h"
#include "qpid/agent/ManagementAgent.h"
#include "NIC.h"
#include "ArgsNICIdentify_nic.h"

#include <iostream>
#include <sstream>

using namespace qmf::com::redhat::matahari;
using           qpid::management::ManagementAgent;
using           qpid::management::Manageable;
using           qpid::management::ManagementObject;
using           qpid::management::Args;
using           qpid::management::Mutex;
using           std::string;

string  NIC::packageName  = string ("com.redhat.matahari");
string  NIC::className    = string ("nic");
uint8_t NIC::md5Sum[MD5_LEN]   =
    {0x88,0xeb,0x2b,0xb0,0xd1,0xc1,0x4f,0x6f,0xbc,0xc4,0x74,0xd,0x77,0x6b,0x3d,0x8d};

NIC::NIC (ManagementAgent*, Manageable* _core, ::qpid::management::Manageable* _parent) :
    ManagementObject(_core)
{
    host = _parent->GetManagementObject ()->getObjectId ();
    macaddr = "";
    interface = "";
    ipaddr = "";
    netmask = "";
    broadcast = "";
    bandwidth = 0;



}

NIC::~NIC ()
{

}

namespace {
    const string NAME("name");
    const string TYPE("type");
    const string ACCESS("access");
    const string IS_INDEX("index");
    const string IS_OPTIONAL("optional");
    const string UNIT("unit");
    const string MIN("min");
    const string MAX("max");
    const string MAXLEN("maxlen");
    const string DESC("desc");
    const string ARGCOUNT("argCount");
    const string ARGS("args");
    const string DIR("dir");
    const string DEFAULT("default");
}

void NIC::registerSelf(ManagementAgent* agent)
{
    agent->registerClass(packageName, className, md5Sum, writeSchema);
}

void NIC::writeSchema (std::string& schema)
{
    const int _bufSize=65536;
    char _msgChars[_bufSize];
    ::qpid::management::Buffer buf(_msgChars, _bufSize);
    ::qpid::types::Variant::Map ft;

    // Schema class header:
    buf.putOctet       (CLASS_KIND_TABLE);
    buf.putShortString (packageName); // Package Name
    buf.putShortString (className);   // Class Name
    buf.putBin128      (md5Sum);      // Schema Hash
    buf.putShort       (7); // Config Element Count
    buf.putShort       (0); // Inst Element Count
    buf.putShort       (1); // Method Count

    // Properties
    ft.clear();
    ft[NAME] = "host";
    ft[TYPE] = TYPE_REF;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Host that this NIC belongs to";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "macaddr";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 1;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "MAC Address";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "interface";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Interface name";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "ipaddr";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "IP Address";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "netmask";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Netmask";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "broadcast";
    ft[TYPE] = TYPE_SSTR;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Broadcast";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "bandwidth";
    ft[TYPE] = TYPE_S32;
    ft[ACCESS] = ACCESS_RO;
    ft[IS_INDEX] = 0;
    ft[IS_OPTIONAL] = 0;
    ft[DESC] = "Bandwidth";
    buf.putMap(ft);


    // Statistics

    // Methods
    ft.clear();
    ft[NAME] =  "identify_nic";
    ft[ARGCOUNT] = 2;
    ft[DESC] = "Physically Identify NIC";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "seconds";
    ft[TYPE] = TYPE_S32;
    ft[DIR] = "I";
    buf.putMap(ft);

    ft.clear();
    ft[NAME] = "ret";
    ft[TYPE] = TYPE_S32;
    ft[DIR] = "O";
    buf.putMap(ft);


    {
        uint32_t _len = buf.getPosition();
        buf.reset();
        buf.getRawData(schema, _len);
    }
}




std::string NIC::getKey() const
{
    std::stringstream key;

    key << host.getV2Key() << ",";
    key << macaddr;
    return key.str();
}



void NIC::mapEncodeValues (::qpid::types::Variant::Map& _map,
                                              bool includeProperties,
                                              bool includeStatistics)
{
    using namespace ::qpid::types;
    Mutex::ScopedLock mutex(accessLock);

    if (includeProperties) {
        configChanged = false;
    _map["host"] = ::qpid::types::Variant(host);
    _map["macaddr"] = ::qpid::types::Variant(macaddr);
    _map["interface"] = ::qpid::types::Variant(interface);
    _map["ipaddr"] = ::qpid::types::Variant(ipaddr);
    _map["netmask"] = ::qpid::types::Variant(netmask);
    _map["broadcast"] = ::qpid::types::Variant(broadcast);
    _map["bandwidth"] = ::qpid::types::Variant(bandwidth);

    }

    if (includeStatistics) {
        instChanged = false;






    // Maintenance of hi-lo statistics


    }
}

void NIC::mapDecodeValues (const ::qpid::types::Variant::Map& _map)
{
    ::qpid::types::Variant::Map::const_iterator _i;
    Mutex::ScopedLock mutex(accessLock);

    if ((_i = _map.find("host")) != _map.end()) {
        host = _i->second;
    }
    if ((_i = _map.find("macaddr")) != _map.end()) {
        macaddr = (_i->second).getString();
    }
    if ((_i = _map.find("interface")) != _map.end()) {
        interface = (_i->second).getString();
    }
    if ((_i = _map.find("ipaddr")) != _map.end()) {
        ipaddr = (_i->second).getString();
    }
    if ((_i = _map.find("netmask")) != _map.end()) {
        netmask = (_i->second).getString();
    }
    if ((_i = _map.find("broadcast")) != _map.end()) {
        broadcast = (_i->second).getString();
    }
    if ((_i = _map.find("bandwidth")) != _map.end()) {
        bandwidth = _i->second;
    }

}

void NIC::doMethod (string& methodName, const ::qpid::types::Variant::Map& inMap, ::qpid::types::Variant::Map& outMap)
{
    Manageable::status_t status = Manageable::STATUS_UNKNOWN_METHOD;
    std::string          text;


    if (methodName == "identify_nic") {
        ArgsNICIdentify_nic ioArgs;
        ::qpid::types::Variant::Map::const_iterator _i;
        if ((_i = inMap.find("seconds")) != inMap.end()) {
            ioArgs.i_seconds = _i->second;
        }
        status = coreObject->ManagementMethod (METHOD_IDENTIFY_NIC, ioArgs, text);
        outMap["_status_code"] = (uint32_t) status;
        outMap["_status_text"] = ::qpid::management::Manageable::StatusText(status, text);
        outMap["ret"] = ::qpid::types::Variant(ioArgs.o_ret);
        return;
    }

    outMap["_status_code"] = (uint32_t) status;
    outMap["_status_text"] = Manageable::StatusText(status, text);
}
